package com.jojubanking.boot.module.system.service.childitem;

import com.jojubanking.boot.framework.mybatis.core.query.LambdaQueryWrapperX;
import com.jojubanking.boot.module.system.controller.app.xytjinfo.vo.ItemListReqVO;
import com.jojubanking.boot.module.system.dal.dataobject.item.ItemDO;
import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;

import java.util.*;
import com.jojubanking.boot.module.system.controller.admin.childitem.vo.*;
import com.jojubanking.boot.module.system.dal.dataobject.childitem.ChilditemDO;
import com.jojubanking.boot.framework.common.pojo.PageResult;

import com.jojubanking.boot.module.system.convert.childitem.ChilditemConvert;
import com.jojubanking.boot.module.system.dal.mysql.childitem.ChilditemMapper;

import static com.jojubanking.boot.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.jojubanking.boot.module.system.enums.ErrorCodeConstants.*;

/**
 * 检查项目子 Service 实现类
 *
 * @author admin
 */
@Service
@Validated
public class ChilditemServiceImpl implements ChilditemService {

    @Resource
    private ChilditemMapper childitemMapper;

    @Override
    public Long createChilditem(ChilditemCreateReqVO createReqVO) {
        // 插入
        ChilditemDO childitem = ChilditemConvert.INSTANCE.convert(createReqVO);
        childitemMapper.insert(childitem);
        // 返回
        return childitem.getId();
    }

    @Override
    public void updateChilditem(ChilditemUpdateReqVO updateReqVO) {
        // 校验存在
        this.validateChilditemExists(updateReqVO.getId());
        // 更新
        ChilditemDO updateObj = ChilditemConvert.INSTANCE.convert(updateReqVO);
        childitemMapper.updateById(updateObj);
    }

    @Override
    public void updateItemPriceByNo(ChilditemDO itemDO){
        childitemMapper.updateItemPriceByNo(itemDO);
    }

    @Override
    public void deleteChilditem(Long id) {
        // 校验存在
        this.validateChilditemExists(id);
        // 删除
        childitemMapper.deleteById(id);
    }

    private void validateChilditemExists(Long id) {
        if (childitemMapper.selectById(id) == null) {
            throw exception(CHILDITEM_NOT_EXISTS);
        }
    }

    @Override
    public ChilditemDO getChilditem(Long id) {
        return childitemMapper.selectById(id);
    }

    @Override
    public List<ChilditemDO> getChilditemList(Collection<Long> ids) {
        return childitemMapper.selectBatchIds(ids);
    }

    @Override
    public List<ChilditemDO> getSimpleItemList(ItemListReqVO itemListReqVO) {
        return childitemMapper.selectSimpleList(itemListReqVO);
    }

    @Override
    public PageResult<ChilditemDO> getChilditemPage(ChilditemPageReqVO pageReqVO) {
        return childitemMapper.selectPage(pageReqVO);
    }

    @Override
    public List<ChilditemDO> getChilditemList(ChilditemExportReqVO exportReqVO) {
        return childitemMapper.selectList(exportReqVO);
    }

}
